angular.module('pb.widgets')
  .directive('pbDatePicker', function() {
    return {
      controllerAs: 'ctrl',
      controller: function PbDatePickerCtrl($scope, $log, widgetNameFactory) {

  'use strict';

  //By default the picker is closed
  this.opened = false;

  this.datepickerOptions = {
    startingDay: 1
  };

  this.today = function() {
    var date = new Date();
    $scope.properties.value = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
  };

  this.open = function ($event) {
    $event.preventDefault();
    $event.stopPropagation();
    this.opened = true;

    if($scope.properties.value===null){
      $log.warn('Your date picker need a data to be bound. Without data, your app doesn\'t know what to do with the date');
    }

  };

  this.name = widgetNameFactory.getName('pbDatepicker');
}
,
      template: '<div ng-class="{\n    \'form-horizontal\': properties.labelPosition === \'left\' && !properties.labelHidden,\n    \'row\': properties.labelPosition === \'top\' && !properties.labelHidden || properties.labelHidden\n    }">\n    <div class="form-group">\n        <label\n            ng-if="!properties.labelHidden"\n            ng-class="{ \'control-label--required\': properties.required }"\n            class="control-label col-xs-{{ !properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 12 }}">\n            {{ properties.label }}\n        </label>\n        <div class="col-xs-{{ 12 - (!properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 0) }}">\n            <p class="input-group">\n                <input type="text" class="form-control"\n                       datepicker-popup="{{ properties.dateFormat }}"\n                       pb-datepicker-utc\n                       name="{{ctrl.name}}"\n                       ng-model="properties.value"\n                       is-open="ctrl.opened"\n                       datepicker-options="ctrl.datepickerOptions"\n                       placeholder="{{properties.placeholder}}"\n                       ng-required="properties.required"\n                       ng-readonly="properties.readOnly"/>\n\n                <span class="input-group-btn">\n                    <button type="button" class="btn btn-default"\n                            ng-click="ctrl.today()"\n                            ng-disabled="properties.readOnly">\n                            Today\n                    </button>\n                    <button type="button" class="btn btn-default"\n                              ng-click="ctrl.open($event)"\n                              ng-disabled="properties.readOnly">\n                              <i class="glyphicon glyphicon-calendar"></i>\n                    </button>\n                </span>\n            </p>\n            <div ng-messages="$form[ctrl.name].$dirty && $form[ctrl.name].$error " ng-messages-include="forms-generic-errors.html" role="alert"></div>\n        </div>\n    </div>\n</div>\n'
    };
  });
